#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_Comment=Same logic as timestomp written by  James C. Foster and Vincent Liu in 2005 (but with some different features)
#AutoIt3Wrapper_Res_Description=Changes MACE timestamps on files/directories as you like
#AutoIt3Wrapper_Res_Fileversion=1.0.0.4
#AutoIt3Wrapper_Res_LegalCopyright=Joakim Schicht
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#RequireAdmin
#include "_WinTimeFunctions.au3";Ascend4nt
#include <FileConstants.au3>

Opt("MustDeclareVars", 1)
Global $file = ""
Global $file2 = ""
Global $IsDirectory = 0
Global $FormattedTimestamp, $FormattedTimestamp1, $filesystem, $drive, $CreationTime2, $LastAccessTime2, $LastWriteTime2, $ChangeTime2, $IsDirectory
Global $CreationTime, $LastAccessTime, $LastWriteTime, $ChangeTime, $CreationTime3, $LastAccessTime3, $LastWriteTime3, $ChangeTime3
Global Const $FileBasicInformation = 4
Global Const $OBJ_CASE_INSENSITIVE = 0x00000040
Global Const $FILE_DIRECTORY_FILE = 0x00000002
Global Const $FILE_NON_DIRECTORY_FILE = 0x00000040
Global Const $FILE_RANDOM_ACCESS = 0x00000800
Global Const $tagFILEBASICINFO = "int64 CreationTime;int64 LastAccessTime;int64 LastWriteTime;int64 ChangeTime;ulong FileAttributes;"
Global Const $tagIOSTATUSBLOCK = "dword Status;ptr Information"
Global Const $tagOBJECTATTRIBUTES = "ulong Length;hwnd RootDirectory;ptr ObjectName;ulong Attributes;ptr SecurityDescriptor;ptr SecurityQualityOfService"
Global Const $tagUNICODESTRING = "ushort Length;ushort MaximumLength;ptr Buffer"
Dim $FormattedTimestamp

ConsoleWrite("Starting SetMACE by Joakim Schicht" & @CRLF)
ConsoleWrite("" & @CRLF)
_validate_parameters()
$drive = StringMid($cmdline[1],1,3)
$filesystem = DriveGetFileSystem($drive)
ConsoleWrite("Filesystem on " & $drive & " is " & $filesystem & @CRLF)
If $cmdline[2] = "-d" Then
	_GetMACE($cmdline[1],$IsDirectory)
	ConsoleWrite("CreationTime: " & $CreationTime3 & @CRLF)
	ConsoleWrite("LastAccessTime: " & $LastAccessTime3 & @CRLF)
	ConsoleWrite("LastWriteTime: " & $LastWriteTime3 & @CRLF)
	ConsoleWrite("ChangeTime: " & $ChangeTime3 & @CRLF)
	ConsoleWrite("FINISHED!!" & @CRLF)
	Exit
EndIf
If $cmdline[2] <> "-g" Then $FormattedTimestamp = _config_timestamp()
If $cmdline[2] <> "-g" AND $FormattedTimestamp = -1 Then
	ConsoleWrite("Error: Timestamp generation failed" & @CRLF)
	Exit
EndIf
If $cmdline[2] <> "-g" AND $cmdline[2] <> "-d" Then
	$FormattedTimestamp1 = StringMid($FormattedTimestamp[0],1,14) & $FormattedTimestamp[8]
	ConsoleWrite("Generated timestamp: " & $FormattedTimestamp1 & @CRLF)
EndIf
If $cmdline[2] = "-g" Then
	_GetMACE($cmdline[3],$IsDirectory)
EndIf
_set_mace($file,$IsDirectory)
If $cmdline[2] = "-g" Then
	ConsoleWrite("FINISHED!!" & @CRLF)
	Exit
EndIf
If $cmdline[4] = "-x" AND $filesystem = "NTFS" Then
	If $IsDirectory = 1 Then
		ConsoleWrite("Skipping -x for directories" & @CRLF)
		ConsoleWrite("FINISHED!!" & @CRLF)
		Exit
	EndIf
	_fn_mace()
EndIf
If $cmdline[4] = "-x" AND $filesystem <> "NTFS" Then
	ConsoleWrite("The -x parameter is only used with NTFS" & @CRLF)
EndIf
ConsoleWrite("FINISHED!!" & @CRLF)
Exit

Func _set_mace($file, $mode)
    Local $hNTDLL = DllOpen("ntdll.dll")
    Local $szName = DllStructCreate("wchar[260]")
    Local $sUS = DllStructCreate($tagUNICODESTRING)
    Local $sOA = DllStructCreate($tagOBJECTATTRIBUTES)
    Local $sISB = DllStructCreate($tagIOSTATUSBLOCK)
    Local $buffer = DllStructCreate("byte[16384]")
    Local $ret, $FILE_MODE
    If $mode == 0 Then
        $FILE_MODE = $FILE_NON_DIRECTORY_FILE
    Else
        $FILE_MODE = $FILE_DIRECTORY_FILE
    EndIf
    $file = "\??\" & $file
    DllStructSetData($szName, 1, $file)
    $ret = DllCall($hNTDLL, "none", "RtlInitUnicodeString", "ptr", DllStructGetPtr($sUS), "ptr", DllStructGetPtr($szName))
    DllStructSetData($sOA, "Length", DllStructGetSize($sOA))
    DllStructSetData($sOA, "RootDirectory", Chr(0))
    DllStructSetData($sOA, "ObjectName", DllStructGetPtr($sUS))
    DllStructSetData($sOA, "Attributes", $OBJ_CASE_INSENSITIVE)
    DllStructSetData($sOA, "SecurityDescriptor", Chr(0))
    DllStructSetData($sOA, "SecurityQualityOfService", Chr(0))
    $ret = DllCall($hNTDLL, "int", "NtOpenFile", "hwnd*", "", "dword", $GENERIC_WRITE, "ptr", DllStructGetPtr($sOA), "ptr", DllStructGetPtr($sISB), _
                                "ulong", $FILE_SHARE_WRITE, "ulong", BitOR($FILE_MODE, $FILE_RANDOM_ACCESS))
	If NT_SUCCESS($ret[0]) Then
;		ConsoleWrite("NtOpenFile: Success" & @CRLF)
	Else
		ConsoleWrite("Error: NtOpenFile Failed" & @CRLF)
		Exit
	EndIf
    Local $hFile = $ret[1]
	Local $pFSO = DllStructGetPtr($buffer)
	Local $sFSO = DllStructCreate($tagFILEBASICINFO, $pFSO)

	Select
		Case $cmdline[2] = "-m"
			DllStructSetData($sFSO, "LastWriteTime",$FormattedTimestamp1)
			ConsoleWrite("Setting timestamp in LastWriteTime" & @CRLF)
		Case $cmdline[2] = "-a"
			DllStructSetData($sFSO, "LastAccessTime",$FormattedTimestamp1)
			ConsoleWrite("Setting timestamp in LastAccessTime" & @CRLF)
		Case $cmdline[2] = "-c"
			DllStructSetData($sFSO, "CreationTime",$FormattedTimestamp1)
			ConsoleWrite("Setting timestamp in CreationTime" & @CRLF)
		Case $cmdline[2] = "-e"
			DllStructSetData($sFSO, "ChangeTime",$FormattedTimestamp1)
			If $filesystem = "NTFS" Then ConsoleWrite("Setting timestamp in ChangeTime" & @CRLF)
			If $filesystem <> "NTFS" Then ConsoleWrite("No need for -e when filesystem is not NTFS" & @CRLF)
		Case $cmdline[2] = "-z"
			DllStructSetData($sFSO, "LastWriteTime",$FormattedTimestamp1)
			DllStructSetData($sFSO, "LastAccessTime",$FormattedTimestamp1)
			DllStructSetData($sFSO, "CreationTime",$FormattedTimestamp1)
			DllStructSetData($sFSO, "ChangeTime",$FormattedTimestamp1)
			If $filesystem = "NTFS" Then ConsoleWrite("Setting all 4 MACE timestamps" & @CRLF)
			If $filesystem <> "NTFS" Then ConsoleWrite("Setting all 3 MAC timestamps" & @CRLF)
		Case $cmdline[2] = "-g"
			DllStructSetData($sFSO, "LastWriteTime",$LastWriteTime)
			DllStructSetData($sFSO, "LastAccessTime",$LastAccessTime)
			DllStructSetData($sFSO, "CreationTime",$CreationTime)
			DllStructSetData($sFSO, "ChangeTime",$ChangeTime)
			If $filesystem = "NTFS" Then ConsoleWrite("Copying all 4 MACE timestamps from: " & $file2 & @CRLF)
			If $filesystem <> "NTFS" Then ConsoleWrite("Copying all 3 MAC timestamps from: " & $file2 & @CRLF)
			ConsoleWrite("LastWriteTime: " & $LastWriteTime3 & @CRLF)
			ConsoleWrite("LastAccessTime: " & $LastAccessTime3 & @CRLF)
			ConsoleWrite("CreationTime: " & $CreationTime3 & @CRLF)
			ConsoleWrite("ChangeTime: " & $ChangeTime3 & @CRLF) ; Throws nothing if FS <> NTFS anyway..
	EndSelect
    $ret = DllCall($hNTDLL, "int", "NtSetInformationFile", "hwnd", $hFile, "ptr", DllStructGetPtr($sISB), "ptr", DllStructGetPtr($sFSO), _
                                "int", 16384, "ptr", $FileBasicInformation)

	If NT_SUCCESS($ret[0]) Then
		ConsoleWrite("NtSetInformationFile: Success" & @CRLF)
	Else
		ConsoleWrite("Error: NtSetInformationFile Failed" & @CRLF)
		Exit
	EndIf
    $ret = DllCall($hNTDLL, "int", "NtClose", "hwnd", $hFile)
    DllClose($hNTDLL)
EndFunc

Func _config_timestamp()
Local $timestamp_array, $input2LocalFileTime[9]
If StringLen($cmdline[3]) <> 28 Then
	ConsoleWrite("Error: Length of date/time is not correct: " & $cmdline[3] & @CRLF)
	Exit
EndIf
$timestamp_array = StringSplit(StringReplace($cmdline[3],'"',''),":")
If $timestamp_array[0] <> 8 Then
	ConsoleWrite("Error: Not right date/time parameters supplied: " & $timestamp_array[0] & @CRLF)
	Exit
EndIf
For $dateinputs = 1 To $timestamp_array[0]
	If StringIsDigit($timestamp_array[$dateinputs]) <> 1 Then
		ConsoleWrite("Error: Not right date/time format supplied: " & $timestamp_array[$dateinputs] & @CRLF)
		Exit
	EndIf
	If StringLen($timestamp_array[$dateinputs]) <> 2 And StringLen($timestamp_array[$dateinputs]) <> 4 And $dateinputs <> 7 Then
		ConsoleWrite("Error: Not right date/time format supplied: " & $timestamp_array[$dateinputs] & @CRLF)
		Exit
	EndIf
	If StringLen($timestamp_array[$dateinputs]) <> 3 And $dateinputs = 7 Then
		ConsoleWrite("Error: Not right date/time format supplied for MilliSec: " & $timestamp_array[$dateinputs] & @CRLF)
		Exit
	EndIf
	If StringLen($timestamp_array[$dateinputs]) <> 4 And $dateinputs = 8 Then
		ConsoleWrite("Error: Not right date/time format supplied for NanoSec: " & $timestamp_array[$dateinputs] & @CRLF)
		Exit
	EndIf
	ContinueLoop
Next
$input2LocalFileTime[0] = _WinTime_SystemTimeToLocalFileTime($timestamp_array[1],$timestamp_array[2],$timestamp_array[3],$timestamp_array[4],$timestamp_array[5],$timestamp_array[6],$timestamp_array[7],-1)
$input2LocalFileTime[1] = $timestamp_array[1]
$input2LocalFileTime[2] = $timestamp_array[2]
$input2LocalFileTime[3] = $timestamp_array[3]
$input2LocalFileTime[4] = $timestamp_array[4]
$input2LocalFileTime[5] = $timestamp_array[5]
$input2LocalFileTime[6] = $timestamp_array[6]
$input2LocalFileTime[7] = $timestamp_array[7]
$input2LocalFileTime[8] = $timestamp_array[8]
Return $input2LocalFileTime
EndFunc

Func _validate_parameters()
Local $FileAttrib
If $cmdline[0] < 2 Then
	ConsoleWrite("Error: Incorrect parameters supplied" & @CRLF)
	ConsoleWrite("Examples:" & @CRLF)
	ConsoleWrite("" & @CRLF)
	ConsoleWrite("Setting all 4 timestamps in both $FILE_NAME and $STANDARD_INFORMATION attributes:" & @CRLF)
	ConsoleWrite('setmace.exe "%CD%\file.txt" -z "2000:01:01:00:00:00:789:1234" -x' & @CRLF)
	ConsoleWrite("" & @CRLF)
	ConsoleWrite("Setting only the LastWriteTime:" & @CRLF)
	ConsoleWrite('setmace.exe "%CD%\file.txt" -m "2000:01:01:00:00:00:789:1234" -n' & @CRLF)
	ConsoleWrite("" & @CRLF)
	ConsoleWrite("Dumping timestamps for a file:" & @CRLF)
	ConsoleWrite('setmace.exe "C:\tmp\file.txt" -d' & @CRLF)
	ConsoleWrite("" & @CRLF)
	ConsoleWrite("Copy timestamps from secondfile.txt and apply them to file.txt:" & @CRLF)
	ConsoleWrite('setmace.exe "C:\file.txt" -g "D:\secondfile.txt"' & @CRLF)
	Exit
EndIf
If $cmdline[2] <> "-d" AND $cmdline[2] <> "-g" Then
	If $cmdline[0] <> 4 Then
		ConsoleWrite("Error: Wrong number of parameters supplied: " & $cmdline[0] & @CRLF)
		Exit
	EndIf
	If $cmdline[4] <> "-x" And $cmdline[4] <> "-n" Then
		ConsoleWrite("Error: Input parameter number 4 is unknown: " & $cmdline[4] & @CRLF)
		Exit
	EndIf
EndIf
If $cmdline[2] = "-d" Then
	If $cmdline[0] <> 2 Then
		ConsoleWrite("Error: Wrong number of parameters supplied: " & $cmdline[0] & @CRLF)
		Exit
	EndIf
EndIf
If $cmdline[2] <> "-m" And  $cmdline[2] <> "-a" And $cmdline[2] <> "-c" And $cmdline[2] <> "-e" And $cmdline[2] <> "-z" And $cmdline[2] <> "-d" And $cmdline[2] <> "-g" Then
	ConsoleWrite("Error: Input parameter number 2 is unknown: " & $cmdline[2] & @CRLF)
	Exit
EndIf
If FileExists($cmdline[1]) <> 1 OR StringMid($cmdline[1],2,2) <> ":\" Then
	ConsoleWrite("Error: Target file does not exist: " & $cmdline[1] & @CRLF)
	Exit
Else
	$FileAttrib = FileGetAttrib($cmdline[1])
	If $FileAttrib <> "D" Then
		$IsDirectory = 0
		ConsoleWrite("Target is a: File" & @CRLF)
	EndIf
	If $FileAttrib = "D" Then
		$IsDirectory = 1
		ConsoleWrite("Target is a: Directory" & @CRLF)
	EndIf
EndIf
If $cmdline[2] = "-g" Then
	If FileExists($cmdline[3]) <> 1 OR StringMid($cmdline[3],2,2) <> ":\" Then
		ConsoleWrite("Error: Target file does not exist: " & $cmdline[3] & @CRLF)
		Exit
	EndIf
	$file2 = $cmdline[3]
EndIf
$file = $cmdline[1]
EndFunc

Func _fn_mace()
Local $l, $rnddir, $mvFile
Local $inptarget_lenght, $targetname, $output_folder, $newfile
$rnddir = Random(99, 99999, 1)
$l = 1
If StringInStr($cmdline[1],"\") Then
	$inptarget_lenght = StringLen($cmdline[1])
	For $l = 1 To $inptarget_lenght
		If StringMid($cmdline[1],$inptarget_lenght-$l,1) = "\" Then ExitLoop
	Next
	$targetname = StringMid($cmdline[1],$inptarget_lenght-$l+1,$l)
EndIf
;ConsoleWrite("$targetname: " & $targetname & @CRLF)
If StringMid(@TempDir,1,3) = $drive Then
	$output_folder = @TempDir & '\' & $rnddir & "\"
Else
	$output_folder = StringMid($cmdline[1],1,$inptarget_lenght-$l) & $rnddir & "\"
EndIf
DirCreate($output_folder)
If $IsDirectory = 1 Then
	$output_folder = StringTrimRight($output_folder,1)
EndIf
;ConsoleWrite("$file: " & $file & @CRLF)
;ConsoleWrite("$output_folder: " & $output_folder & @CRLF)
If $IsDirectory = 0 Then
	$mvFile = FileMove($file,$output_folder,9)
Else
	$mvFile = DirMove($file,$output_folder,1)
EndIf
If $mvFile = 0 Then
	_GrantFileAccess($file)
	If $IsDirectory = 0 Then
		$mvFile = FileMove($file,$output_folder,9)
	Else
		$mvFile = DirMove($file,$output_folder,1)
	EndIf
	If $mvFile = 0 Then
		ConsoleWrite("Error: Probably file permission issues" & @CRLF)
		Exit
	EndIf
EndIf
If $IsDirectory = 1 Then
	$newfile = $output_folder & "\" & $targetname
Else
	$newfile = $output_folder & $targetname
EndIf
_set_mace($newfile,$IsDirectory)
;$mvFile = FileMove($newfile,$file)
If $IsDirectory = 0 Then
	$mvFile = FileMove($newfile,$file)
Else
	$mvFile = DirMove($newfile,$file,1)
EndIf
If $mvFile = 0 Then
;	ConsoleWrite("Error2: When moving file" & @CRLF)
	_GrantFileAccess($newfile)
;	$mvFile = FileMove($newfile,$file,1)
	If $IsDirectory = 0 Then
		$mvFile = FileMove($newfile,$file,1)
	Else
		$mvFile = DirMove($newfile,$file,1)
	EndIf
	If $mvFile = 0 Then
		ConsoleWrite("Error: Probably file permission issues" & @CRLF)
		Exit
	EndIf
EndIf
_set_mace($file,$IsDirectory)
DirRemove($output_folder,1)
EndFunc

Func NT_SUCCESS($status)
    If 0 <= $status And $status <= 0x7FFFFFFF Then
        Return True
    Else
        Return False
    EndIf
EndFunc

Func _GetMACE($file, $mode)
	Local $tTimestamps[5]
    Local $hNTDLL = DllOpen("ntdll.dll")
    Local $szName = DllStructCreate("wchar[260]")
    Local $sUS = DllStructCreate($tagUNICODESTRING)
    Local $sOA = DllStructCreate($tagOBJECTATTRIBUTES)
    Local $sISB = DllStructCreate($tagIOSTATUSBLOCK)
    Local $buffer = DllStructCreate("byte[16384]")
    Local $ret, $FILE_MODE
    If $mode == 0 Then
        $FILE_MODE = $FILE_NON_DIRECTORY_FILE
    Else
        $FILE_MODE = $FILE_DIRECTORY_FILE
    EndIf
    $file = "\??\" & $file
    DllStructSetData($szName, 1, $file)
    $ret = DllCall($hNTDLL, "none", "RtlInitUnicodeString", "ptr", DllStructGetPtr($sUS), "ptr", DllStructGetPtr($szName))
    DllStructSetData($sOA, "Length", DllStructGetSize($sOA))
    DllStructSetData($sOA, "RootDirectory", Chr(0))
    DllStructSetData($sOA, "ObjectName", DllStructGetPtr($sUS))
    DllStructSetData($sOA, "Attributes", $OBJ_CASE_INSENSITIVE)
    DllStructSetData($sOA, "SecurityDescriptor", Chr(0))
    DllStructSetData($sOA, "SecurityQualityOfService", Chr(0))
    $ret = DllCall($hNTDLL, "int", "NtOpenFile", "hwnd*", "", "dword", $GENERIC_READ, "ptr", DllStructGetPtr($sOA), "ptr", DllStructGetPtr($sISB), _
                                "ulong", $FILE_SHARE_READ, "ulong", BitOR($FILE_MODE, $FILE_RANDOM_ACCESS))
	If NT_SUCCESS($ret[0]) Then
;		ConsoleWrite("NtOpenFile: Success" & @CRLF)
	Else
		ConsoleWrite("Error: NtOpenFile Failed" & @CRLF)
		Exit
	EndIf
    Local $hFile = $ret[1]
    $ret = DllCall($hNTDLL, "int", "NtQueryInformationFile", "ptr", $hFile, "ptr", DllStructGetPtr($sISB), "ptr", DllStructGetPtr($buffer), _
                                "int", 16384, "ptr", $FileBasicInformation)

    If NT_SUCCESS($ret[0]) Then
        ConsoleWrite("NtQueryInformationFile: Success" & @CRLF)
        Local $pFSO = DllStructGetPtr($buffer)
        Local $sFSO = DllStructCreate($tagFILEBASICINFO, $pFSO)
; Maybe switch from Global and return a complete array instead of a simpel array
        Global $CreationTime = DllStructGetData($sFSO, "CreationTime")
		Global $CreationTime1 = _WinTime_UTCFileTimeFormat($CreationTime,4,2)
		Global $CreationTime2 = $CreationTime1 & ":" & StringRight($CreationTime,4)
		Global $CreationTime3 = $CreationTime1 & ":" & _FillZero(StringRight($CreationTime,4))
        Global $LastAccessTime = DllStructGetData($sFSO, "LastAccessTime")
		Global $LastAccessTime1 = _WinTime_UTCFileTimeFormat($LastAccessTime,4,2)
		Global $LastAccessTime2 = $LastAccessTime1 & ":" & StringRight($LastAccessTime,4)
		Global $LastAccessTime3 = $LastAccessTime1 & ":" & _FillZero(StringRight($LastAccessTime,4))
        Global $LastWriteTime = DllStructGetData($sFSO, "LastWriteTime")
		Global $LastWriteTime1 = _WinTime_UTCFileTimeFormat($LastWriteTime,4,2)
		Global $LastWriteTime2 = $LastWriteTime1 & ":" & StringRight($LastWriteTime,4)
		Global $LastWriteTime3 = $LastWriteTime1 & ":" & _FillZero(StringRight($LastWriteTime,4))
        Global $ChangeTime = DllStructGetData($sFSO, "ChangeTime")
		Global $ChangeTime1 = _WinTime_UTCFileTimeFormat($ChangeTime,4,2)
		Global $ChangeTime2 = $ChangeTime1 & ":" & StringRight($ChangeTime,4)
		Global $ChangeTime3 = $ChangeTime1 & ":" & _FillZero(StringRight($ChangeTime,4))
		Global $FileAttributes = DllStructGetData($sFSO, "FileAttributes")
		$tTimestamps[0] = $CreationTime
		$tTimestamps[1] = $LastAccessTime
		$tTimestamps[2] = $LastWriteTime
		$tTimestamps[3] = $ChangeTime
		$tTimestamps[4] = $FileAttributes
    Else
        ConsoleWrite("Error: NtQueryInformationFile Failed" & @CRLF)
		Exit
    EndIf
    $ret = DllCall($hNTDLL, "int", "NtClose", "hwnd", $hFile)
    DllClose($hNTDLL)
	Return $tTimestamps
EndFunc

Func _FillZero($inp)
Local $inplen, $out, $tmp = ""
$inplen = StringLen($inp)
For $i = 1 To 4-$inplen
	$tmp &= "0"
Next
$out = $tmp & $inp
Return $out
EndFunc

Func _GrantFileAccess($exe)
	If @OSBuild >= 6000 Then
		Run(@ComSpec & " /c " & @WindowsDir & '\system32\takeown.exe /f ' & $exe, "", @SW_HIDE)
		Run(@ComSpec & " /c " & @WindowsDir & '\system32\icacls.exe ' & $exe & ' /grant *S-1-5-32-544:F', "", @SW_HIDE)
		Return
	EndIf
EndFunc
